package lab04;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Question {
	private int questionNumber;
	private String question;
	private String[] answers;
	private int correct;
	private QuestionResponseEventHandler responseHandler;

	private JFrame frame;

	public Question(int questionNumber, String question, String[] answers, int correct,
			QuestionResponseEventHandler responseHandler) throws Exception {
		this.questionNumber = questionNumber;
		this.question = question;
		this.answers = answers;
		this.correct = correct;
		this.responseHandler = responseHandler;

		if (answers.length != 4) {
			throw new Exception("Should be exactly 4 answers");
		}
		if (correct < 0 || correct > 3) {
			throw new Exception("Correct answer should be valid");
		}

		this.renderForm();
	}

	private void renderForm() {
		frame = new JFrame("Question #" + String.valueOf(this.questionNumber));

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		panel.add(new JLabel(question));

		JPanel answers = new JPanel();

		Question that = this;
		for (int i = 0; i < 4; i++) {
			JButton button = new JButton(this.answers[i]);
			boolean isCorrect = i == correct;
			button.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					that.handleAnswer(isCorrect);
				}
			});
			answers.add(button);
		}

		panel.add(answers);

		frame.add(panel);

		frame.setSize(500, 150);
		frame.setVisible(true);
	}

	private void handleAnswer(boolean isCorrect) {
		if (isCorrect) {
			JOptionPane.showMessageDialog(frame, "Your answer is correct!", "Hurray!", JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog(frame, "Your answers is wrong. The correct is: " + this.answers[this.correct],
					"Oof", JOptionPane.ERROR_MESSAGE);
		}

		this.frame.setVisible(false);
		this.responseHandler.onResponse(isCorrect);
	}
}
